var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs", "path", "./copy-file", "./create-folder", "./file-exists"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const fs_1 = __importDefault(require("fs"));
    const path_1 = require("path");
    const copy_file_1 = __importDefault(require("./copy-file"));
    const create_folder_1 = __importDefault(require("./create-folder"));
    const file_exists_1 = __importDefault(require("./file-exists"));
    const copyFolder = (source, target, depth = 0) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, e_1, _b, _c;
        if (!source.includes('.git')) {
            let files = [];
            // Check if folder needs to be created or integrated
            const targetFolder = (0, path_1.join)(target, (0, path_1.basename)(depth ? source : '.'));
            if (!(yield (0, file_exists_1.default)(targetFolder))) {
                yield (0, create_folder_1.default)(targetFolder);
            }
            // Copy
            if (fs_1.default.lstatSync(source).isDirectory() ||
                fs_1.default.lstatSync(source).isSymbolicLink()) {
                files = fs_1.default.readdirSync(source);
                try {
                    for (var _d = true, files_1 = __asyncValues(files), files_1_1; files_1_1 = yield files_1.next(), _a = files_1_1.done, !_a;) {
                        _c = files_1_1.value;
                        _d = false;
                        try {
                            const file = _c;
                            let curSource = (0, path_1.join)(source, file);
                            if (fs_1.default.lstatSync(curSource).isDirectory()) {
                                yield copyFolder(curSource, targetFolder, ++depth);
                            }
                            else {
                                yield (0, copy_file_1.default)(curSource, targetFolder);
                            }
                        }
                        finally {
                            _d = true;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (!_d && !_a && (_b = files_1.return)) yield _b.call(files_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        }
    });
    exports.default = copyFolder;
});
