var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "fs", "@gluestack/helpers", "./write-sdk-function", "@gluestack-v2/framework-cli/build/helpers/file/get-file-name-without-ext"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const path_1 = __importDefault(require("path"));
    const fs_1 = __importStar(require("fs"));
    const helpers_1 = require("@gluestack/helpers");
    const write_sdk_function_1 = __importDefault(require("./write-sdk-function"));
    const get_file_name_without_ext_1 = __importDefault(require("@gluestack-v2/framework-cli/build/helpers/file/get-file-name-without-ext"));
    function filePathExtension(filePath) {
        var _a;
        return (_a = filePath.split('.').pop()) !== null && _a !== void 0 ? _a : '';
    }
    const functionsMap = {};
    function getNestedFilePaths(dirPath, fileList = []) {
        const files = fs_1.default.readdirSync(dirPath);
        files.forEach((file) => {
            const filePath = path_1.default.join(dirPath, file);
            const stats = fs_1.default.statSync(filePath);
            if (stats.isDirectory()) {
                // If the file is a directory, recursively call the function
                // to get nested file paths
                getNestedFilePaths(filePath, fileList);
            }
            else {
                // If the file is a regular file, add its path to the fileList
                fileList.push(filePath);
            }
        });
        return fileList;
    }
    const createFunctionFromPath = (path, value, sdkFunction) => {
        const pathArr = path.split('/');
        // console.log(sdkFunction);
        const obj = {};
        let current = obj;
        for (let i = 0; i < pathArr.length - 1; i++) {
            if (pathArr[i] !== '') {
                // if (i == pathArr.length - 1) {
                //   console.log(i, "in if");
                //   current[pathArr[i]] = sdkFunction;
                // } else {
                current[pathArr[i]] = {};
                // }
                current = current[pathArr[i]];
            }
        }
        current[pathArr[pathArr.length - 1]] = '****' + path + '****';
        functionsMap['****' + path + '****'] = sdkFunction;
        return obj;
    };
    const deepMerge = (obj1, obj2) => {
        const output = Object.assign({}, obj1);
        for (const key in obj2) {
            if (obj2.hasOwnProperty(key)) {
                if (typeof obj2[key] === 'object' &&
                    obj1.hasOwnProperty(key) &&
                    typeof obj1[key] === 'object') {
                    output[key] = deepMerge(obj1[key], obj2[key]);
                }
                else {
                    output[key] = obj2[key];
                }
            }
        }
        return output;
    };
    const writeSDK = (packagePath, installationPath, sdkPath, ignoredPaths, instanceName) => __awaiter(void 0, void 0, void 0, function* () {
        let obj = {};
        const packageSdkSrcIndex = path_1.default.join(packagePath, 'src', 'index.ts');
        const files = getNestedFilePaths(installationPath);
        let finalString = ``;
        files.forEach((functionFile, _index) => {
            const filePath = functionFile;
            if (['json'].includes(filePathExtension(filePath)) ||
                filePath.includes('node_modules')) {
                return;
            }
            for (let i = 0; i < ignoredPaths.length; i++) {
                if (filePath.includes('/' + ignoredPaths[i] + '/')) {
                    return;
                }
            }
            // console.log(filePath, 'filePath>>>>>>>');
            const functionName = (0, get_file_name_without_ext_1.default)(filePath);
            // HACK: This is a hack to get the function path
            let functionPath = filePath.replace(installationPath, '');
            // let functionPath = filePath.replace(installationPath, '');
            functionPath = functionPath.split('.').slice(0, -1).join('.');
            // console.log(functionPath, 'functionPath', functionName, 'functionName');
            // console.log(
            //   installationPath,
            //   'installationPath>>>>>>.',
            //   packagePath,
            //   'packagePath>>>>>>.'
            // );
            const functionCodeString = fs_1.default.readFileSync(filePath, 'utf8');
            const regex = /const\s*\{\s*([^}]+)\s*\}\s*=\s*ctx.params\s*;/;
            const matches = functionCodeString.match(regex);
            let params = [];
            if (matches && matches[1]) {
                params = matches[1].split(/\s*,\s*/);
            }
            else {
                params = [];
                console.error('NO MATCHES FOR PARMAS IN THE PROVIDED FUNCTION ' + functionName);
            }
            // console.log(ign);
            const sdkFunction = (0, write_sdk_function_1.default)(instanceName, params, functionPath);
            // console.log(createFunctionFromPath(functionPath, {}, sdkFunction));
            obj = Object.assign(Object.assign({}, obj), deepMerge(obj, createFunctionFromPath(functionPath, {}, sdkFunction)));
            // console.log(obj, 'OBJJJJJ', Object.keys(obj));
            // finalString = JSON.stringify(obj);
            // finalString = finalString.substring(1, finalString.length - 1);
            // console.log(functionsMap, 'functionsMap');
            // Object.keys(functionsMap).map((key: any) => {
            //   finalString = finalString.replace(`"${key}"`, functionsMap[key]);
            // });
            // console.log(finalString, 'finalString');
            // sdkFunction += sdkFunction + '\n';
        });
        Object.keys(obj).map((key) => {
            // console.log(JSON.stringify(obj[key]), 'obj[key]');
            const functionString = `${key}=`;
            if (typeof obj[key] === 'string') {
                if (!finalString.includes(functionString + obj[key])) {
                    finalString = finalString + functionString + obj[key];
                }
            }
            else {
                if (!finalString.includes(functionString + JSON.stringify(obj[key]))) {
                    finalString = finalString + functionString + JSON.stringify(obj[key]);
                }
            }
            // finalString=finalString+
        });
        // console.log(functionsMap);
        Object.keys(functionsMap).map((key) => {
            finalString = finalString.replace(`"${key}"`, functionsMap[key]);
            finalString = finalString.replace(`'${key}'`, functionsMap[key]);
            finalString = finalString.replace(`${key}`, functionsMap[key]);
        });
        const sdkFileContent = (0, fs_1.readFileSync)(path_1.default.join(sdkPath, 'src', 'index.ts')).toString();
        // console.log(finalString, 'SDK FILE CONTENTNNNNN');
        // Create SDK index file with all the functions
        yield (0, helpers_1.writeFile)(packageSdkSrcIndex, sdkFileContent.replace('// **---Functions will be added after this---**', finalString));
    });
    exports.default = writeSDK;
});
